Index: src/main/java/org/jboss/dna/jcr/JcrRepository.java
===================================================================
--- src/main/java/org/jboss/dna/jcr/JcrRepository.java	(revision 1377)
+++ src/main/java/org/jboss/dna/jcr/JcrRepository.java	(working copy)
@@ -37,6 +37,9 @@
 import java.util.Set;
 import java.util.concurrent.ConcurrentHashMap;
 import java.util.concurrent.ConcurrentMap;
+import java.util.concurrent.CopyOnWriteArrayList;
+import java.util.concurrent.ExecutorService;
+import java.util.concurrent.Executors;
 import javax.jcr.Credentials;
 import javax.jcr.NoSuchWorkspaceException;
 import javax.jcr.Repository;
@@ -68,6 +71,7 @@
 import org.jboss.dna.graph.connector.federation.ProjectionParser;
 import org.jboss.dna.graph.connector.inmemory.InMemoryRepositorySource;
 import org.jboss.dna.graph.observe.Changes;
+import org.jboss.dna.graph.observe.Observable;
 import org.jboss.dna.graph.observe.Observer;
 import org.jboss.dna.graph.property.Name;
 import org.jboss.dna.graph.property.NamespaceRegistry;
@@ -215,24 +219,8 @@
     private final String systemWorkspaceName;
     private final Projection systemSourceProjection;
     private final FederatedRepositorySource federatedSource;
-    private final Observer observer;
     private final NamespaceRegistry persistentRegistry;
-
-    /**
-     * Creates a JCR repository that uses the supplied {@link RepositoryConnectionFactory repository connection factory} to
-     * establish {@link Session sessions} to the underlying repository source upon {@link #login() login}.
-     * 
-     * @param executionContext An execution context.
-     * @param connectionFactory A repository connection factory.
-     * @param repositorySourceName the name of the repository source (in the connection factory) that should be used
-     * @throws IllegalArgumentException If <code>executionContextFactory</code> or <code>connectionFactory</code> is
-     *         <code>null</code>.
-     */
-    public JcrRepository( ExecutionContext executionContext,
-                          RepositoryConnectionFactory connectionFactory,
-                          String repositorySourceName ) {
-        this(executionContext, connectionFactory, repositorySourceName, null, null);
-    }
+    private final RepositoryObservationManager repositoryObservationManager;
 
     /**
      * Creates a JCR repository that uses the supplied {@link RepositoryConnectionFactory repository connection factory} to
@@ -241,19 +229,23 @@
      * @param executionContext the execution context in which this repository is to operate
      * @param connectionFactory the factory for repository connections
      * @param repositorySourceName the name of the repository source (in the connection factory) that should be used
+     * @param repositoryObservable the repository library observable associated with this repository (never <code>null</code>)
      * @param descriptors the {@link #getDescriptorKeys() descriptors} for this repository; may be <code>null</code>.
      * @param options the optional {@link Option settings} for this repository; may be null
-     * @throws IllegalArgumentException If <code>executionContextFactory</code> or <code>connectionFactory</code> is
-     *         <code>null</code>.
+     * @throws IllegalArgumentException If <code>executionContext</code>, <code>connectionFactory</code>, 
+     *         <code>repositorySourceName</code>, or <code>repositoryObservable</code> is <code>null</code>.
      */
     public JcrRepository( ExecutionContext executionContext,
                           RepositoryConnectionFactory connectionFactory,
                           String repositorySourceName,
+                          Observable repositoryObservable,
                           Map<String, String> descriptors,
                           Map<Option, String> options ) {
         CheckArg.isNotNull(executionContext, "executionContext");
         CheckArg.isNotNull(connectionFactory, "connectionFactory");
         CheckArg.isNotNull(repositorySourceName, "repositorySourceName");
+        CheckArg.isNotNull(repositoryObservable, "repositoryObservable");
+
         Map<String, String> modifiableDescriptors;
         if (descriptors == null) {
             modifiableDescriptors = new HashMap<String, String>();
@@ -264,7 +256,7 @@
         modifiableDescriptors.put(Repository.LEVEL_1_SUPPORTED, "true");
         modifiableDescriptors.put(Repository.LEVEL_2_SUPPORTED, "true");
         modifiableDescriptors.put(Repository.OPTION_LOCKING_SUPPORTED, "true");
-        modifiableDescriptors.put(Repository.OPTION_OBSERVATION_SUPPORTED, "false");
+        modifiableDescriptors.put(Repository.OPTION_OBSERVATION_SUPPORTED, "true");
         modifiableDescriptors.put(Repository.OPTION_QUERY_SQL_SUPPORTED, "false");
         modifiableDescriptors.put(Repository.OPTION_TRANSACTIONS_SUPPORTED, "false");
         modifiableDescriptors.put(Repository.OPTION_VERSIONING_SUPPORTED, "false");
@@ -297,8 +289,9 @@
             this.options = Collections.unmodifiableMap(localOptions);
         }
 
-        // Initialize the observer, which receives events from all repository sources ...
-        this.observer = new RepositoryObserver();
+        // Initialize the observer, which receives events from all repository sources
+        this.repositoryObservationManager = new RepositoryObservationManager();
+        repositoryObservable.register(this.repositoryObservationManager);
 
         // Set up the system source ...
         String systemSourceNameValue = this.options.get(Option.SYSTEM_SOURCE_NAME);
@@ -490,7 +483,16 @@
      * @return the current observer, or null if there is no observer
      */
     Observer getObserver() {
-        return observer;
+        return this.repositoryObservationManager;
+    }
+
+    /**
+     * The repository observable that listeners can be registered with.
+     * 
+     * @return the repository observable (never <code>null</code>)
+     */
+    Observable getRepositoryObservable() {
+        return this.repositoryObservationManager;
     }
 
     /**
@@ -833,14 +835,48 @@
         }
     }
 
-    protected class RepositoryObserver implements Observer {
+    protected class RepositoryObservationManager implements Observable, Observer {
+        
+        private final ExecutorService observerService = Executors.newSingleThreadExecutor();
+        private final CopyOnWriteArrayList<Observer> observers = new CopyOnWriteArrayList<Observer>();
+
         /**
          * {@inheritDoc}
          * 
          * @see org.jboss.dna.graph.observe.Observer#notify(org.jboss.dna.graph.observe.Changes)
          */
-        public void notify( Changes changes ) {
-            // does nothing at the moment, but eventually will fire to all of the listeners on the appropriate sessions
+        public void notify( final Changes changes ) {
+            final List<Observer> listeners = observers;
+            
+            Runnable command = new Runnable() {
+                public void run() {
+                    for (Observer observer : listeners) {
+                        observer.notify(changes);
+                    }
+                }                
+            };
+
+            this.observerService.execute(command);
+        }
+
+        /**
+         * {@inheritDoc}
+         *
+         * @see org.jboss.dna.graph.observe.Observable#register(org.jboss.dna.graph.observe.Observer)
+         */
+        public boolean register( Observer observer ) {
+            CheckArg.isNotNull(observer, "observer");
+            return this.observers.addIfAbsent(observer);
+        }
+
+        /**
+         * {@inheritDoc}
+         *
+         * @see org.jboss.dna.graph.observe.Observable#unregister(org.jboss.dna.graph.observe.Observer)
+         */
+        public boolean unregister( Observer observer ) {
+            CheckArg.isNotNull(observer, "observer");
+            return this.observers.remove(observer);
         }
     }
 
Index: src/main/java/org/jboss/dna/jcr/WorkspaceLockManager.java
===================================================================
--- src/main/java/org/jboss/dna/jcr/WorkspaceLockManager.java	(revision 1377)
+++ src/main/java/org/jboss/dna/jcr/WorkspaceLockManager.java	(working copy)
@@ -189,12 +189,12 @@
             ExecutionContext context = session.getExecutionContext();
             PathFactory pathFactory = context.getValueFactories().getPathFactory();
 
+            // Remove the lock node under the /jcr:system branch ...
             Graph.Batch batch = repository.createSystemGraph(context).batch();
-
             batch.delete(pathFactory.create(locksPath, pathFactory.createSegment(lock.getUuid().toString())));
-            batch.remove(JcrLexicon.LOCK_OWNER, JcrLexicon.LOCK_IS_DEEP).on(lock.nodeUuid);
             batch.execute();
 
+            // Unlock the node in the repository graph ...
             unlockNodeInRepository(session, lock);
 
             workspaceLocksByNodeUuid.remove(lock.nodeUuid);
@@ -208,7 +208,6 @@
                 throw new IllegalStateException(pnfe);
             }
             workspaceLocksByNodeUuid.remove(lock.nodeUuid);
-
         }
     }
 
Index: src/test/java/org/jboss/dna/jcr/JcrRepositoryTest.java
===================================================================
--- src/test/java/org/jboss/dna/jcr/JcrRepositoryTest.java	(revision 1377)
+++ src/test/java/org/jboss/dna/jcr/JcrRepositoryTest.java	(working copy)
@@ -49,6 +49,7 @@
 import org.jboss.dna.graph.connector.RepositoryConnectionFactory;
 import org.jboss.dna.graph.connector.RepositorySourceException;
 import org.jboss.dna.graph.connector.inmemory.InMemoryRepositorySource;
+import org.jboss.dna.graph.observe.MockObservable;
 import org.jboss.security.config.IDTrustConfiguration;
 import org.junit.After;
 import org.junit.Before;
@@ -113,7 +114,7 @@
 
         // Set up the repository ...
         descriptors = new HashMap<String, String>();
-        repository = new JcrRepository(context, connectionFactory, sourceName, descriptors, null);
+        repository = new JcrRepository(context, connectionFactory, sourceName, new MockObservable(), descriptors, null);
 
         // Set up the graph that goes directly to the source ...
         sourceGraph = Graph.create(source, context);
@@ -135,22 +136,27 @@
 
     @Test
     public void shouldAllowNullDescriptors() {
-        new JcrRepository(context, connectionFactory, sourceName, null, null);
+        new JcrRepository(context, connectionFactory, sourceName, new MockObservable(), null, null);
     }
 
     @Test( expected = IllegalArgumentException.class )
     public void shouldNotAllowNullExecutionContext() throws Exception {
-        new JcrRepository(null, connectionFactory, sourceName, descriptors, null);
+        new JcrRepository(null, connectionFactory, sourceName, new MockObservable(), descriptors, null);
     }
 
     @Test( expected = IllegalArgumentException.class )
     public void shouldNotAllowNullConnectionFactories() throws Exception {
-        new JcrRepository(context, null, sourceName, descriptors, null);
+        new JcrRepository(context, null, sourceName, new MockObservable(), descriptors, null);
+    }
+
+    @Test( expected = IllegalArgumentException.class )
+    public void shouldNotAllowNullObservable() throws Exception {
+        new JcrRepository(context, connectionFactory, sourceName, null, null, null);
     }
 
     @Test( expected = IllegalArgumentException.class )
     public void shouldNotAllowNullSourceName() throws Exception {
-        new JcrRepository(context, connectionFactory, null, descriptors, null);
+        new JcrRepository(context, connectionFactory, null, new MockObservable(), descriptors, null);
     }
 
     @Test( expected = IllegalArgumentException.class )
@@ -175,14 +181,24 @@
 
     @Test
     public void shouldProvideBuiltInDescriptorsWhenNotSuppliedDescriptors() {
-        Repository repository = new JcrRepository(context, connectionFactory, sourceName, descriptors, null);
+        Repository repository = new JcrRepository(context, connectionFactory, sourceName, new MockObservable(), descriptors, null);
         testDescriptorKeys(repository);
         testDescriptorValues(repository);
     }
+    
+    @Test
+    public void shouldProvideObserver() {
+        assertThat(this.repository.getObserver(), is(notNullValue()));
+    }
+    
+    @Test
+    public void shouldProvideRepositoryObservable() {
+        assertThat(this.repository.getRepositoryObservable(), is(notNullValue()));
+    }
 
     @Test
     public void shouldHaveDefaultOptionsWhenNotOverridden() {
-        JcrRepository repository = new JcrRepository(context, connectionFactory, sourceName, descriptors, null);
+        JcrRepository repository = new JcrRepository(context, connectionFactory, sourceName, new MockObservable(), descriptors, null);
         assertThat(repository.getOptions().get(JcrRepository.Option.PROJECT_NODE_TYPES),
                    is(JcrRepository.DefaultOption.PROJECT_NODE_TYPES));
     }
@@ -191,7 +207,7 @@
     public void shouldProvideUserSuppliedDescriptors() {
         Map<String, String> descriptors = new HashMap<String, String>();
         descriptors.put("property", "value");
-        Repository repository = new JcrRepository(context, connectionFactory, sourceName, descriptors, null);
+        Repository repository = new JcrRepository(context, connectionFactory, sourceName, new MockObservable(), descriptors, null);
         testDescriptorKeys(repository);
         testDescriptorValues(repository);
         assertThat(repository.getDescriptor("property"), is("value"));
@@ -433,7 +449,7 @@
         assertThat(repository.getDescriptor(Repository.LEVEL_1_SUPPORTED), is("true"));
         assertThat(repository.getDescriptor(Repository.LEVEL_2_SUPPORTED), is("true"));
         assertThat(repository.getDescriptor(Repository.OPTION_LOCKING_SUPPORTED), is("true"));
-        assertThat(repository.getDescriptor(Repository.OPTION_OBSERVATION_SUPPORTED), is("false"));
+        assertThat(repository.getDescriptor(Repository.OPTION_OBSERVATION_SUPPORTED), is("true"));
         assertThat(repository.getDescriptor(Repository.OPTION_QUERY_SQL_SUPPORTED), is("false"));
         assertThat(repository.getDescriptor(Repository.OPTION_TRANSACTIONS_SUPPORTED), is("false"));
         assertThat(repository.getDescriptor(Repository.OPTION_VERSIONING_SUPPORTED), is("false"));
